program DXFscaling;

uses
crt;

var
indfil, udfil : text;
streng : string;
float : single;
code: integer;
signed : boolean;
indnavn, udnavn : string;
scaleX : single;
scaleY : single;
scaleZ : single;

procedure rwnode (scale : single);
begin
   signed := FALSE;
   if streng [1] = ' ' then
      begin
      streng := copy (streng,2, length(streng)-2);
      end;
   if streng [1] = '-' then
      begin
      streng := copy (streng,2, length(streng)-2);
      signed := TRUE;
      end;
   val (streng, float, code);
   float := float * scale;
   str (float:0:5, streng);
   if signed then streng := '-'+streng;
   writeln (udfil, streng);
   readln (indfil, streng);
   writeln (udfil, streng);
end;

begin
writeln ('DXF scaling build 1 by Michael Andersen.');
writeln ('Simple scaling program for DXF files,');
writeln ('which keeps the node order.');
write ('Input DXF file:');
readln (indnavn);
write ('output DXF file:');
readln (udnavn);
write ('Scale X 1 to ?:');
readln (scaleX);
write ('Scale Y 1 to ?:');
readln (scaleY);
write ('Scale Z 1 to ?:');
readln (scaleZ);

assign (indfil, indnavn);
reset (indfil);
assign (udfil, udnavn);
rewrite (udfil);

repeat
readln (indfil, streng);
writeln (udfil, streng);
until streng = '3DFACE';

repeat
readln (indfil, streng);
writeln (udfil, streng);
readln (indfil, streng);
writeln (udfil, streng);
readln (indfil, streng);
writeln (udfil, streng);
repeat
readln (indfil, streng);
if eof (indfil) then
   begin
   writeln ('Error reading input file format.');
   halt;
   end;
if (streng <> '3DFACE') and (streng <> 'ENDSEC') then
   begin
   rwnode (scalex);
   readln (indfil, streng);
   rwnode (scaley);
   readln (indfil, streng);
   rwnode (scalez);
   end;
until (streng = '3DFACE') or (streng = 'ENDSEC');
writeln (udfil, streng);
until streng = 'ENDSEC';

readln (indfil, streng);
writeln (udfil, streng);
readln (indfil, streng);
writeln (udfil, streng);
close (indfil);
close (udfil);
writeln;
writeln ('Done!');
end.